/*
	KeyMap.h
	
	Contains all of the GetKeys() codes for all of the keys on the keyboard.
*/

#define	ESC_POS	1
#define	ESC_KEY	0x00002000

#define TAB_POS	1
#define TAB_KEY	0x00000100

#define SPC_POS	1
#define SPC_KEY	0x00000200

#define SPACE_POS	1
#define SPACE_KEY	0x00000200

// The arrow keys
#define LEFT_ARROW_POS	3
#define LEFT_ARROW_KEY	0x00000088

#define RIGHT_ARROW_POS	3
#define RIGHT_ARROW_KEY	0x00000090

#define UP_ARROW_POS	3
#define UP_ARROW_KEY	0x000000c0

#define DOWN_ARROW_POS	3
#define DOWN_ARROW_KEY	0x000000a0

// The command keys (and caps lock) can only be used in combination with other keys.
// They will not register by themselves with GetKeys().
#define	COMMAND_POS	1
#define COMMAND_KEY	0x00008000

#define OPTION_POS	1
#define OPTION_KEY	0x00000004

#define CONTROL_POS	1
#define CONTROL_KEY	0x00000008

#define SHIFT_POS	1
#define SHIFT_KEY	0x00000001

#define	CAPS_POS	1
#define CAPS_KEY	0x00000002

// the number keys
#define ONE_POS	0
#define ONE_KEY	0x00000400

#define TWO_POS	0
#define TWO_KEY	0x00000800

#define THREE_POS	0
#define THREE_KEY	0x00001000

#define FOUR_POS	0
#define FOUR_KEY	0x00002000

#define FIVE_POS	0
#define FIVE_KEY	0x00008000

#define SIX_POS	0
#define SIX_KEY	0x00004000

#define SEVEN_POS	0
#define SEVEN_KEY	0x00000004

#define EIGHT_POS	0
#define EIGHT_KEY	0x00000010

#define NINE_POS	0
#define NINE_KEY	0x00000002

#define ZERO_POS	0
#define ZERO_KEY	0x00000020

// all of the alphanumeric keys (these are actually lowercase)
#define A_POS	0
#define A_KEY	0x01000000

#define B_POS	0
#define B_KEY	0x00080000

#define C_POS	0
#define C_KEY	0x00010000

#define D_POS	0
#define D_KEY	0x04000000

#define E_POS	0
#define E_KEY	0x00400000

#define F_POS	0
#define F_KEY	0x08000000

#define G_POS	0
#define G_KEY	0x20000000

#define H_POS	0
#define H_KEY	0x10000000

#define I_POS	1
#define I_KEY	0x04000000

#define J_POS	1
#define J_KEY	0x40000000

#define K_POS	1
#define K_KEY	0x00010000

#define L_POS	1
#define L_KEY	0x20000000

#define M_POS	1
#define M_KEY	0x00400000

#define N_POS	1
#define N_KEY	0x00200000

#define O_POS	0
#define O_KEY	0x00000080

#define P_POS	1
#define P_KEY	0x08000000

#define Q_POS	0
#define Q_KEY	0x00100000

#define R_POS	0
#define R_KEY	0x00800000

#define S_POS	0
#define S_KEY	0x02000000

#define T_POS	0
#define T_KEY	0x00000200

#define U_POS	1
#define U_KEY	0x01000000

#define V_POS	0
#define V_KEY	0x00020000

#define W_POS	0
#define W_KEY	0x00200000

#define X_POS	0
#define X_KEY	0x80000000

#define Y_POS	0
#define Y_KEY	0x00000100

#define Z_POS	0
#define Z_KEY	0x40000000

// now for all of those extra characters: -=[]\;',./
#define	DASH_POS	0
#define DASH_KEY	0x00000008

#define MINUS_POS	0
#define MINUS_KEY	0x00000008

#define EQ_POS		0
#define EQ_KEY		0x00000001

#define EQUAL_POS	0
#define EQUAL_KEY	0x00000001

#define BRACKET_LEFT_POS	1
#define BRACKET_LEFT_KEY	0x02000000

#define BRACKET_RIGHT_POS	0
#define BRACKET_RIGHT_KEY	0x00000040

#define BACKSLASH_POS	1
#define BACKSLASH_KEY	0x00040000

#define SEMICOLON_POS	1
#define SEMICOLON_KEY	0x00020000

#define QUOTE_POS	1
#define QUOTE_KEY	0x80000000

#define COMMA_POS	1
#define COMMA_KEY	0x00080000

#define PERIOD_POS	1
#define PERIOD_KEY	0x00800000

#define SLASH_POS	1
#define SLASH_KEY	0x00100000

#define BACK_QUOTE_POS	1
#define BACK_QUOTE_KEY	0x00000400

// function keys
#define	F1_POS	3
#define	F1_KEY	0x00000004

#define	F2_POS	3
#define	F2_KEY	0x00000001

#define	F3_POS	3
#define	F3_KEY	0x08000000

#define	F4_POS	3
#define	F4_KEY	0x00004000

#define	F5_POS	3
#define	F5_KEY	0x01000000

#define	F6_POS	3
#define	F6_KEY	0x02000000

#define	F7_POS	3
#define	F7_KEY	0x04000000

#define	F8_POS	3
#define	F8_KEY	0x10000000

#define	F9_POS	3
#define	F9_KEY	0x20000000

#define	F10_POS	3
#define	F10_KEY	0x00200000

#define	F11_POS	3
#define	F11_KEY	0x80000000

#define	F12_POS	3
#define	F12_KEY	0x00800000

#define	F13_POS	3
#define	F13_KEY	0x00020000

#define	F14_POS	3
#define	F14_KEY	0x00080000

#define	F15_POS	3
#define	F15_KEY	0x00000200

// the keypad
#define KP_CLEAR_POS	2
#define KP_CLEAR_KEY	0x80000000

#define KP_EQUAL_POS	2
#define KP_EQUAL_KEY	0x00000200

#define KP_SLASH_POS	2
#define KP_SLASH_KEY	0x00080000

#define KP_DIV_POS		2
#define KP_DIV_KEY		0x00080000

#define KP_STAR_POS		2
#define KP_STAR_KEY		0x08000000

#define KP_TIMES_POS	2
#define KP_TIMES_KEY	0x08000000

#define KP_MINUS_POS	2
#define KP_MINUS_KEY	0x00400000

#define KP_PLUS_POS		2
#define KP_PLUS_KEY		0x20000000

#define KP_ENTER_POS	2
#define KP_ENTER_KEY	0x00100000

#define KP_DOT_POS		2
#define KP_DOT_KEY		0x02000000

#define KP_PERIOD_POS	2
#define KP_PERIOD_KEY	0x02000000

// the numbers on the keypad
#define KP_ONE_POS		2
#define KP_ONE_KEY		0x00000800

#define KP_TWO_POS		2
#define KP_TWO_KEY		0x00001000

#define KP_THREE_POS	2
#define KP_THREE_KEY	0x00002000

#define KP_FOUR_POS		2
#define KP_FOUR_KEY		0x00004000

#define KP_FIVE_POS		2
#define KP_FIVE_KEY		0x00008000

#define KP_SIX_POS		2
#define KP_SIX_KEY		0x00000001

#define KP_SEVEN_POS	2
#define KP_SEVEN_KEY	0x00000002

#define KP_EIGHT_POS	2
#define KP_EIGHT_KEY	0x00000008

#define KP_NINE_POS		2
#define KP_NINE_KEY		0x00000010

#define KP_ZERO_POS		2
#define KP_ZERO_KEY		0x00000400

// those keys to the upper left of the keypad
#define HELP_POS		3
#define	HELP_KEY		0x00000480

#define HOME_POS		3
#define HOME_KEY		0x00000880

#define PAGE_UP_POS		3
#define PAGE_UP_KEY		0x00001080

#define FWD_DEL_POS		3
#define FWD_DEL_KEY		0x00002080

#define END_POS			3
#define END_KEY			0x00008080

#define PAGE_DOWN_POS	3
#define PAGE_DOWN_KEY	0x00000082