// ===========================================================================
//	CNeuroSimApp.h				1996 Timo Eloranta
// ===========================================================================
//	An application class derived from the PowerPlant LApplication class.
//	This class handles the menu commands and owns the neural net and the
//	window inside of which our pane object is.

#pragma once							// Include this header only once

#include "NS_Types.h"

#include <LApplication.h>				// PowerPlant application class

class	LWindow;						// Forward class declarations
class	CNeuralNet;

class	CNeuroSimApp : public LApplication {

	protected:
		CNeuralNet		*mNet;			// Pointer to the neural net
		
		LWindow 		*mWindow;		// Pointer to the main window

		SGenParams		mParams;		// Parameter struct used in
										// creating the neural net

		virtual void		InitNewNet();
		virtual void		ShowAboutBox();
		void				RegisterClasses();
		
	public:
							CNeuroSimApp();
		virtual 			~CNeuroSimApp();
		
		virtual Boolean		ObeyCommand(		CommandT inCommand, 
												void *ioParam = nil );
		virtual void		FindCommandStatus(	CommandT inCommand,
												Boolean &outEnabled,
												Boolean &outUsesMark,
												Char16 &outMark,
												Str255 outName );
};