// ===========================================================================
//	CParamsDialog.h				1996 Timo Eloranta
// ===========================================================================
//	This class handles the dialog where the user can view and modify the
//	parameters of a new neural net. CParamsDialog is derived from LDialogBox - 
//	a PowerPlant window class with default (OK) and Cancel buttons.

#pragma once						// Include this header only once

#include <LDialogBox.h>
#include <LCaption.h>				
#include <LEditField.h>
#include <LStdControl.h>

#include "NS_Types.h"
#include "Slider.h"

class CParamsDialog : public LDialogBox {
public:
	enum {
		class_ID = 'PDlg'			// ID used by Metrowerks Constructor
	};

	static 	CParamsDialog * CreateParamsDialogStream( LStream *inStream );
	
					CParamsDialog ( LStream *theStream );
	virtual			~CParamsDialog() {};

	virtual void	InitDialog();
	
	virtual void	SetValues( SGenParams &inParams );
	virtual void	GetValues( SGenParams &outParams );

	virtual void	ListenToMessage( MessageT inMessage, void *ioParam );

	virtual void	FindCommandStatus(CommandT inCommand,
						Boolean &outEnabled, Boolean &outUsesMark,
						Char16 &outMark, Str255 outName);
protected:

	HorzSlider		* mSizeSlider;
	LCaption		* mSizeCapt;

	LEditField		* mMinEdit;
	LEditField		* mMaxEdit;
	LEditField		* mAvg_X_Edit;
	LEditField		* mDev_X_Edit;
	LEditField		* mAvg_Y_Edit;
	LEditField		* mDev_Y_Edit;
	
	LStdButton		* mFactoryButton;
	
	virtual void	SetSizeValue( Int16 inValue );
	virtual void	SetDefaultValues();
};
