#ifndef PICS_INFO_H_
#define PICS_INFO_H_

typedef struct {
	short isColor;			// 0=b&w, 1=color
	short depth;
	short speed;			// Speed in fps (1-200)
	short version;			// Currently 0
	OSType creatorType;		// Creator type of application
	long largestFrameSize;	// If non-zero, size of largest frame, in bytes
} PICSInfo, *PICSInfoPtr, **PICSInfoHdl;


// Extended PICS info structure
typedef struct {
	PICSInfo info;
} ExtPICSInfo, *ExtPICSInfoPtr, **ExtPICSInfoHdl;

typedef PICSInfoHdl PICSInfoRsrcHdl;
typedef ExtPICSInfoHdl ExtPICSInfoRsrcHdl;

// ---------------------------------------------------------------------------

/*
	All of the routines assume you have already set the
	file you want to read/save the PICSInfo via
	UseResFile()
*/

PICSInfoRsrcHdl GetPICSInfo();
void DisposePICSInfo(PICSInfoRsrcHdl picsInfo);
Boolean SavePICSInfo(PICSInfoRsrcHdl picsInfo, Boolean isResource);
PICSInfoHdl NewPICSInfo();
PICSInfoRsrcHdl NewPICSInfoResource();


#endif // PICS_INFO_H_