#include "PICS_Operations.h"

#include "PICSViewer.h"
#include "PICS_Merge.h"
#include "PICS_Split.h"
#include "PICSPreferencesDialog.h"
#include "PICSCompositeDialog.h"
#include "PICS_Composite.h"

#include "MovableModalDialogs.h"

// ---------------------------------------------------------------------------

static short sOperation = kPlayOperation;

void SetDragAndDropOperation(short operation) {
	sOperation = operation;
} // END SetDragAndDropOperation

short GetDragAndDropOperation() {
	return(sOperation);
} // END GetDragAndDropOperation

// ---------------------------------------------------------------------------

void FileDispatcher(short numFiles, FSSpec *file) {
	short i;

	// If a movable modal dialog is open, don't allow users
	// to drag and drop files
	if (IsMovableModal(FrontWindow())) {
		SysBeep(10);
		return;
	}

	switch(sOperation) {
		case kPlayOperation:
			for (i = 0; i < numFiles; i++)
				NewPICSViewer(&file[i]);
		break;

		case kCompositeOperation:
			for (i = 0; i < numFiles; i++) {
				SetupPICSFileComposite(&file[i], NULL);
			}
		break;

		case kSplitOperation:
			for (i = 0; i < numFiles; i++) {
				SetupPICSFileSplit(&file[i]);
			}
		break;

		case kMergeOperation:
			SetupMergePICTFiles(numFiles, file);
		break;
	}
} // END FileDispatcherMultiple