#ifndef MOVABLEMODALDIALOGS_H_
#define MOVABLEMODALDIALOGS_H_

typedef void (*AdjustMenusProc)(void);

typedef Boolean (*DialogFilterHandler)(DialogPtr targetDlog, EventRecord *theEvt);

typedef void (*DialogUpdateHandler)(DialogPtr targetDlog, EventRecord *theEvt, Boolean frontMost);
typedef void (*DialogHitHandler)(DialogPtr targetDlog, EventRecord *theEvt, short itemHit);
typedef DialogFilterHandler DialogKeyHandler;
typedef void (*DialogActivateHandler)(DialogPtr targetDlog, Boolean activate);
typedef void (*DialogIdleHandler)(DialogPtr targetDlog);

// ---------------------------------------------------------------------------

/*
	Since modeless and movable modeless dialogs are handled almost
	exactly identical, you may register BOTH modeless and movable
	dialog boxes.
*/

void InitMovableModalDialogs(AdjustMenusProc adjustMenus);

void RegisterMovableModalDialog(
	DialogPtr				theDialog,
	DialogHitHandler		hitProc,
	DialogKeyHandler		keyProc,
	DialogUpdateHandler		updateProc,
	DialogActivateHandler	activateProc,
	DialogIdleHandler		idleProc);

void UnregisterMovableModalDialog(DialogPtr theDialog);

void HandleContentClickModeless(EventRecord *theEvt, DialogPtr theDialog, short itemHit);
Boolean HandleKeyDownModeless(DialogPtr theDialog, EventRecord *theEvt);
void HandleActivateModeless(DialogPtr theDialog, Boolean activate);
void HandleIdleModeless(DialogPtr theDialog);

void HandleUpdateDialog(DialogPtr theDialog, EventRecord *theEvt, Boolean inBackground);


Boolean IsMovableModal(WindowPtr thisWindow);

#endif // MOVABLEMODALDIALOGS_H_